package com.vandyo.sentry.core.cases;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.vandyo.sentry.core.dto.Res;
import com.vandyo.sentry.core.tools.Signature;

import java.util.HashMap;
import java.util.Map;

public class CarListDecorator extends CaseDecorator {

    private final static String carListUrl = "/car/my_car/list";

    public CarListDecorator(Case aCase) {
        super(aCase);
    }

    @Override
    public Res<Map<String, String>> check() {
        Res<Map<String, String>> oldRes = super.check();
        if (oldRes.getSuccess()) {
            Map<String,String> data = new HashMap<>();
            data.put("uid",oldRes.getUId());
            HttpResponse response = HttpRequest.get(Signature.host+carListUrl+"?"
                    +Signature.getUrlParamsByMap(Signature.sign(data,oldRes.getSId())))
                    .execute();
            Res<Map<String, String>> newRes = new Res<>();
            newRes.setSId(oldRes.getSId());
            newRes.setUId(oldRes.getUId());

            if (response.isOk()){
                JSONObject json = JSONUtil.parseObj(response.body());
                JSONArray list = json.getJSONArray("result");
                
                //todo
                newRes.setSuccess(true);
            }else {
                newRes.setSuccess(false);
            }
            return newRes;
        } else {
            return oldRes;
        }
    }
}
